# coding: utf-8

require 'overlord'

module Turn
  class BucketMap
    attr_accessor :buckets, :count

    def initialize(term)
      @term = term
      @buckets = []
      @count = 0
    end

    def load(dc)
      parse(@term.dump_bucket_map(dc))
    end

    def parse(map)
      map.each_with_index do |bucket, index|
        if /(?<id>\S+):\s+(?<value>\d+)/ =~ bucket
          @count = value.to_i
          @buckets[index] = id
        end
      end
    end
  end
end
