# coding: utf-8

require 'rest_client'

module Turn
  class Term
    def initialize(hostname, port)
      @hostname = hostname
      @port = port
    end

    def dump_bucket_map(dc)
      hash = get('dump profile bucket map', dc: dc)

      fail hash['errors'] unless hash['errors'].empty?

      hash['info']
    end

    def dump_public_metrics(prefix)
      metrics = {}

      hash = get('dump public metrics', prefix: prefix)
      hash['rows'].each do |metric|
        metrics[metric.first] = metric.last.to_i
      end

      metrics
    end

    def get(command, query)
      q = { command: command, 'response-formatter' => 'json' }
      uri = URI("http://#{@hostname}:#{@port}/execute")
      uri.query = URI.encode_www_form(q.merge(query))
      json = RestClient.get(uri.to_s)
      hash = JSON.parse(json)

      fail unless hash['errors'].empty? && hash['warnings'].empty?

      hash
    end
  end
end
